#include "Xbp.ch"
#include "Common.ch"
#include "Inkey.ch"
#include "directry.CH"
#include "xbtdisk.ch"
#include "ot4xb.ch"

#pragma library( "XBTBASE1.LIB" )
#pragma library( "XBTBASE2.LIB" )

#define  MAX_TESTFILE  2000000 // 2000000 // Extremtest mit 2.000.000 Dateien dauert etwas lnger, nur die Dateierstellung.

#ifndef CRLF
   #define CRLF chr(13)+chr(10)
#endif

* Dieses Programm soll viele Dateien suchen und den Dateinamen an eine andere funktion bergeben.
* Geschwindigkeitsvergleich zwischen FileFind() und DIR *.* /B ....

* Umlaute check,   - ANSI Quellcode !

procedure main
   local nWahl

   set charset to ansi


   set alternate to TestDirRead.txt
   set alternate on
   ? "Xbase++",Version(),"("+Version(1)+"."+Version(2)+"."+Version(3)+")"
   ?
   ? "Start von TestDirRead",date(),time()
   ?
   ? "ExePath(): ", ExePath()
   ?

   cls

   @ 1,1 say "Dateinamen aus einem vollen Verzeichnis ermitteln"
   @ 3,1 say "Speedtest"
   @ 4,1 say "0 = Testdateien erzeugen  "
   @ 5,1 say "1 = FindFile() aus den Tools "
   @ 6,1 say "2 = DIR *.* /B > TempFile(), HBTextReader()  "
   @ 7,1 say "3 = Ramses FileFind Klasse "

   @10,1 say "Andere Eingabe beendet das Programm: "

   @14,1 say "Testart:        " // 14,17 fr Anzeige
   @15,1 say "gefunden:       " // 15,17 fr Anzeige
   @16,1 say "aktuelle Datei: " // 16,17 fr Anzeige

   // Keines Falles alle Treffer anzeigen, sonst viel zu langsam, Schrittweite 1000 ok ?

   do while .t.
      @14,17 CLEAR TO 14,79
      @15,17 CLEAR TO 15,79
      @16,17 CLEAR TO 16,79
      @10,40 say " "
      nWahl := inkey(0)
      @20,0 CLEAR TO 20,79
      @17,0 say ""
      do case
         case nWahl == asc("0")
              MakeTestFiles()
         case nWahl == asc("1")
              TesteFindFile()
         case nWahl == asc("2")
              TesteDIR()
         case nWahl == asc("3")
              TesteRamsesFindFile()
         otherwise
              exit
      end

      @20,10 say "Fertig"

   enddo

   ? "Programmende"
   set alternate to

return

*----------------------------------------------------------------
function MyAction(x,cFileName,nAttr) // Abbruch => .t. sonst .f.
   if x <= 10 .or. right(Str(x,12),3)=="000"
      @16,17 CLEAR TO 16,79
      @15,18 say x picture "999,999,999,999"
      @16,17 say ConvToOEMCP(cFileName)+"  "+iif(FExists(DataPath()+cFileName),"gefunden","fehlt")
      set console off
      ? "Datei:",x,cFileName,"gefunden ? ",FExists(DataPath()+cFileName),"Time:",time(),"   FA:", nAttr, FAttr(DataPath()+cFileName)
      set console on
   endif

   if inkey() = K_ESC
      set console off
      ? "Abbruch"
      set console on
      Return .t.
   endif

//   sleep(0) // mit 0 bremst es etwas (etwa 50 %), mit 1 bremst es stark !!!

return .f.

*----------------------------------------------------------------
function ExePath()
   local cDrive := CurDrive()
   local cPfad  := CurDir(cDrive)
return cDrive + ":\" + cPfad + "\"
*----------------------------------------------------------------
function DataPath()
return ExePath()+"Daten\"
*----------------------------------------------------------------
function DQ() // erleichtert das schreiben von CMD Commandos da Dateinamen in " eingefasst werden mssen
   local cReturn := '"'
return cReturn
*----------------------------------------------------------------
procedure MakeTestFiles()
   local nDauer, cFile, cTxt, nH
   local x, nAnzahl := 1300000

   @14,17 say "MakeTestFiles()"
   set console off
   ?
   ? "Aktion: MakeTestFiles() ",date(),Time()
   ?
   nDauer := seconds()
   set console on

   CreateDir( left(DataPath(),len(DataPath())-1))

   for x := 1 to nAnzahl
       cFile  := "T_"+strZero(x,7)+".txt"
       cTxt   := "Text in Datei "+cFile
       if ! fExists(DataPath()+cFile)
          nH  := FCreate(DataPath()+cFile)
          IF nH = -1
             ? "Datei konnte nicht erstellt werden:", FError(), DataPath()+cFile
             inkey(3)
             quit
          ELSE
             FWrite( nH, cTxt )
             FClose( nH )
          ENDIF
       endif
       if MyAction(x,cFile,FileAttr(DataPath()+cFile))
          exit
       endif
   next

   if .f. // Test erschweren !

      CreateDir( DataPath()+"AnfangDir" )
      CreateDir( DataPath()+"EndeDir" )
      CreateDir( DataPath()+"HiddenDir" )
      nH  := FCreate(DataPath()+"HiddenFile.txt")
      FWrite( nH, "versteckte Datei" )
      FClose( nH )
      FAttr(     DataPath()+"HiddenFile.txt", "+H" )    // verstecktes Verzeichnis
      FAttr(     DataPath()+"HiddenDir", "+H" )         // verstecktes Verzeichnis
      FAttr(     DataPath()+"T_0000001.txt","-A")    // Archivbit lschen, bei meinem Explorer gibt das N als Attribut => 128
      FAttr(     DataPath()+"T_0000003.txt","-A+R")
      FAttr(     DataPath()+"T_0000005.txt","+R")
   endif


   nDauer := seconds() - nDauer

   set console off
   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"
   set console on

return
*----------------------------------------------------------------
procedure TesteFindFile()
   local nDauer, cFile, nFile, cSuchString, nAttr

   @14,17 say "TesteFindFile()"
   set console off
   ?
   ? "Aktion: TesteFindFile()"
   ?

   nDauer := seconds()

   set console on

   cSuchString := DataPath()+"*.*"

   // Definition in xbtdisk.ch fr FA_NORMAL ist 0, laut Microsoft API Definition aber 128 !!!!
   // Dateien mit im Explorer gelschtem Archivbit werden dort als N angezeigt, hier als 0, fileseek() findet sie nicht.
   cFile := FileSeek( cSuchString ) // FA_NORMAL + FA_ARCHIVE, cFile kann auch Verzeichnisse enthalten !!!
   nFile := 0

   set console off
   ?
   ? "Suchbegriff: ", cSuchString
   ?
   if empty(cFile)
      ? "cFile := FileSeek( cSuchString ) ergibt keinen Treffer !"
   endif

   set console on

   // bAnd() ist aus OT4XB oder Version 2.00, entspricht NumAND() aus den XBToolsIII

   do while ! empty(cFile)
      nAttr := FileAttr(DataPath()+cFile)
      do case
         case NumAnd( nAttr, FA_DIRECTORY ) =  FA_DIRECTORY
              set console off
              ? "Verzeichnis ignorieren !        FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         case NumAnd( nAttr, FA_HIDDEN )    =  FA_HIDDEN
              set console off
              ? "Versteckte besser ignorieren !  FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         case NumAnd( nAttr, FA_SYSTEM )    =  FA_SYSTEM
              set console off
              ? "Systemdatei besser ignorieren ! FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         otherwise
              nFile++
              if MyAction( nFile, cFile, nAttr )
                 exit
              endif
      end
      cFile := FileSeek()
   enddo

   nDauer := seconds() - nDauer

   set console off
   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"
   set console on

return

*----------------------------------------------------------------
procedure TesteDIR()
   local nDauer, cTempFile, oTR, cCMD
   local nFile, cFile, nAttr


   @14,17 say "TesteDIR()"
   set console off
   ?
   ? "Aktion: TesteDIR()", date(), time()
   ?

   nDauer := seconds()

   cTempFile := ExePath()+"TMP"+alltrim(str(seconds(),12,0))+".txt"

   ? "Temporre Datei erstellen: ", cTempFile
   ? "Start: ",date(),time()

   cCMD := "/C DIR "+DQ()+DataPath()+"*.*"+DQ()+" /B > "+DQ()+cTempFile+DQ()

   ? "RunShell() mit DIR /B:     ",;             // Rckgabewert anzeigen
     RunShell( cCMD ) // Eventuelle Blanks bercksichtigen
   ? "Ende:  ",date(),time(),"Lnge der Datei:", filesize(cTempFile)
   ? "Dauer fr DIR /B :", seconds() - nDauer , "Sekunden"

   oTR := HBTextReader( cTempFile ) // per Funktion

   if oTR:FError() <> 0
      @20,1 say "Fehler beim Datei ffnen: "+oTR:ErrMsg()
      ? "Fehler beim Datei ffnen: "+oTR:ErrMsg()
      inkey(3)
      quit
   endif

   nFile := 0

   do while ! oTR:EOF()

      cFile := oTR:GetLine() // zuerst den Dateinamen holen, intern wird auf nchste Zeile gesetzt

      // Wie sich herausstellte sind die Dateinamen in der temporren Datei in OEM !!!
      // Dateifunktionen sind meist aber ANSI ... besser Umlaute vermeiden ;-)

      cFile := ConvToAnsiCP( cFile )

      // hier knnen auch Verzeichnisse enthalten sein !!!

      nAttr := FileAttr(DataPath()+cFile)
      do case
         case NumAnd( nAttr, FA_DIRECTORY ) =  FA_DIRECTORY
              set console off
              ? "Verzeichnis ignorieren !        FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         case NumAnd( nAttr, FA_HIDDEN )    =  FA_HIDDEN // diese sollten gar nicht geliefert werden !
              set console off
              ? "Versteckte besser ignorieren !  FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         case NumAnd( nAttr, FA_SYSTEM )    =  FA_SYSTEM // diese sollten gar nicht geliefert werden !
              set console off
              ? "Systemdatei besser ignorieren ! FA:", FileAttr( DataPath()+cFile ),PadRight( FAttr(DataPath()+cFile),5) + cFile
              set console on
         otherwise
              nFile++
              if MyAction( nFile, cFile, nAttr )
                 exit
              endif
      end

   enddo

   oTR:Destroy()
   delete file (cTempFile)

   nDauer := seconds() - nDauer

   set console off

   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"

   set console on

return
*-------------------------------------------------------------------------
procedure TesteRamsesFindFile()
   local nDauer, nFile, cSuchString
    local oObj
   @14,17 say "TesteRamsesFindFile()"
   set console off
   ?
   ? "Aktion: TesteRamsesFindFile()"
   ?

   nDauer := seconds()

   set console on

   cSuchString := DataPath()+"*.*"

   oObj  := findfile():new()
   oObj:findfile(cSuchString)
   nFile := 0

   set console off
   ? "Suchbegriff: ", cSuchString
   ?
   set console on

   do while ! empty( oObj:cFilenameLong)
      // Vorgabe ist, Verzeichnisse ausschlieen, Dateien mit oder ohne Archiv, auch ReadOnly mssen gefunden werden
      //
      // mit dieser Klausel wird eine Datei die nur ReadOnly ohne Archiv gesetzt ist nicht gefunden !
      // if (bAnd(oObj:nAttr, 0x80 ) =  0x80 .or. bAnd(oObj:nAttr, 0x20 ) =  0x20) .and. ! bAnd(oObj:nAttr, 0x10 ) =  0x10
      // FILE_ATTRIBUTE_DIRECTORY = 16 (0x10)
      //  ? oObj:cFilenameLong
      //
      // Hidden und System ausschlieen
      //

      do case
         case bAnd( oObj:nAttr, FA_DIRECTORY ) =  FA_DIRECTORY
              set console off
              ? "Verzeichnis ignorieren !                                           FA:", oObj:nAttr,PadRight( FAttr(DataPath()+oObj:cFilenameLong),5) + oObj:cFilenameLong
              set console on
         case bAnd( oObj:nAttr, FA_HIDDEN )    =  FA_HIDDEN
              set console off
              ? "Versteckte besser ignorieren !                                     FA:", oObj:nAttr,PadRight( FAttr(DataPath()+oObj:cFilenameLong),5) + oObj:cFilenameLong
              set console on
         case bAnd( oObj:nAttr, FA_SYSTEM )    =  FA_SYSTEM
              set console off
              ? "Systemdatei besser ignorieren !                                    FA:", oObj:nAttr,PadRight( FAttr(DataPath()+oObj:cFilenameLong),5) + oObj:cFilenameLong
              set console on
         case lower(oObj:cFilenameLong) == "desktop.ini"
              set console off
              ? "gefundene Datei: desktop.ini ist nicht erwnscht oder vorhanden ...", oObj:cFilenameLong, " berspringen, FA:",oObj:nAttr,PadRight( FAttr(DataPath()+cFile),5) + oObj:cFilenameLong
              set console on
         otherwise
              nFile++
              if MyAction( nFile, oObj:cFilenameLong, oObj:nAttr )
                 exit
              endif
      end
      oObj:findfile()
   enddo

   oObj:close()

   // wait

   nDauer := seconds() - nDauer
   set console off
   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"
   set console on
return

*############################### HBTextReader ###########################################

* Klasse zum sequentiellen Einlesen groer Dateien
* Da die Blockgre auf 4 KB begrenzt ist, kann man auch einfach die Zeilen ausschneiden.

#include "Fileio.ch"

function HBTextReader( cFile )
   local oTR := HBTxtReader():new( cFile )
return oTR

CLASS HBTxtReader
  PROTECTED:
     VAR nH
     VAR nLastError
     VAR IsEOF           // Buffer hat beim Einlesen EOF erreicht, Zeilen knnen noch da sein !
     VAR cRest
     VAR nBufferBytes    // Anzahl der gelesenen Byte im Buffer
     VAR cCRLF, nLenCRLF // Unix/Linux nur chr(10) = 1 Byte, Windows chr(13)+chr(10) = 2 Byte
     VAR Line
     METHOD ReadBuffer

  EXPORTED:
     METHOD Init
     METHOD Destroy
     METHOD GetLine
     METHOD GoTop
     METHOD FSize
     METHOD FError
     METHOD ErrMsg
     METHOD EOF
     METHOD IsCrLf
     METHOD IsUnix
     METHOD IsMac
     INLINE METHOD RecNo    ; RETURN ::line
     INLINE METHOD LenCrLf  ; RETURN ::nLenCRLF
     METHOD FileType

ENDCLASS

METHOD HBTxtReader:Init( cFileName )       // ffnet die Datei zum Lesen
   ::nLastError   := 0
   ::cRest        := ""
   ::nBufferBytes := 0
   ::Line         := 0
   ::nH    := fopen( cFileName , FO_READ + FO_SHARED )
   if ::nH = -1
      ::nLastError := FError()
      ::IsEOF      := .t.
   else
      ::IsEOF      := .f.
      ::ReadBuffer()
      do case
         case chr(13)+chr(10) $ ::cRest // Windows etc.
              ::cCRLF    := chr(13)+chr(10)
              ::nLenCRLF := 2
         case chr(10)         $ ::cRest // Unix
              ::cCRLF    := chr(10)
              ::nLenCRLF := 1
         case chr(13)         $ ::cRest // Mac
              ::cCRLF    := chr(13)
              ::nLenCRLF := 1
      end
   endif
RETURN SELF

METHOD HBTxtReader:Destroy()
   if ::nH <> -1
      FClose(::nH)
      ::nH := -1
   endif
   ::cRest := ""
RETURN SELF

METHOD HBTxtReader:ReadBuffer()
   local cBuffer, nBufferLen, nBytes
   if ::nH > -1
      nBufferLen := 4096
      cBuffer    := space(nBufferLen)
      nBytes     := FRead( ::nH, @cBuffer, nBufferLen)
      cBuffer    := StrTran(cBuffer,chr(26)," ")
      ::nBufferBytes += nBytes
      if nBufferLen = nBytes // mitten in Datei
         ::cRest += cBuffer
      else
         ::cRest += left(cBuffer,nBytes)
         ::IsEOF := .t.
         if FError() <> 0
            ::nLastError := FError()
         endif
      endif
      cBuffer := ""
   endif
Return

METHOD HBTxtReader:GetLine()
   local nPosCRLF
   local cLine := ""
   do while ! ::cCRLF $ ::cRest .and. ! ::IsEof  // Buffer einlesen, bis wir neue Zeilen haben oder die Datei gelesen wurde
      ::ReadBuffer()
   enddo
   nPosCRLF := at( ::cCRLF, ::cRest)
   if nPosCRLF > 0 // es gibt noch eine komplette Zeile, zurckgeben und krzen
      cLine   := left(::cRest,nPosCRLF-1)
      ::cRest := substr(::cRest,nPosCRLF+::nLenCRLF)
   else
      cLine   := ::cRest
      ::cRest := ""
   endif
   ::Line++
return cLine

METHOD HBTxtReader:GoTop()
   if ::nH <> -1
      FSeek(::nH, 0 , FS_SET )
   endif
   ::cRest   := ""  // zwingt zum neu einlesen
   ::Line    := 0
   ::ReadBuffer()
return NIL

METHOD HBTxtReader:FSize()
   local nSize := 0
   if ::nH <> -1
      nSize := FSize(::nH)
   endif
RETURN nSize

METHOD HBTxtReader:FError()
RETURN ::nLastError

METHOD HBTxtReader:EOF()
RETURN ::IsEOF .and. empty(::cRest)

METHOD HBTxtReader:IsCrLf()
RETURN (::cCRLF == chr(13)+chr(10))

METHOD HBTxtReader:IsUnix()
RETURN (::cCRLF == chr(10))

METHOD HBTxtReader:IsMac()
RETURN (::cCRLF == chr(13))

METHOD HBTxtReader:ErrMsg()
RETURN DosErrorMessage(::nLastError)

METHOD HBTxtReader:FileType()
   local cTxt := ""
   do case
      case ::IsCrLf()
           cTxt := "CRLF"
      case ::IsUnix()
           cTxt := "UNIX/Linux"
      case ::IsMac()
           cTxt := "MAC"
   end
return cTxt

*#################################################### Carlos FindFile Klasse ##############

class findfile
   exported
   var nHandle, nAttr, cfilenameLong, cFilenameShort
   method init, findfile, close
endclass

method findfile:init()
   ::nHandle := -1
   ::cfilenameLong  := ""
   ::cFilenameShort := ""
   ::nAttr := 0
return(self)

method findfile:findfile(cMask,nAttr)
   local ret_val := "", oNetR, nRet

   ::cfilenameLong  := ::cFilenameShort := ""
   oNetR := NETRESOURCE():new()
   oNetR:_alloc_()

   if cMask = nil
      nRet := @Kernel32:FindNextFileA(::nHandle, @oNetR )
   else
      if nAttr != nil
        oNetR:nAttribute := nAttr
      endif
      ::nHandle := nRet := @Kernel32:FindFirstFileA(cMask, @oNetR )
   endif
   ::nAttr := oNetR:nAttribute
   if nRet > 0
      ret_val :=  alltrim(oNetR:cFilename)
      ::cfilenameLong  := oNetR:cFilename
      ::cFilenameShort := oNetR:cAltName
   endif
   oNetR:_free_(.F.)

return(ret_val)


method findfile:close()
   if ::nHandle > 0
      if @Kernel32:FindClose(::nhandle) == 0
         msgbox( "Error FileClose")
      endif
   endif
return(nil)

BEGIN STRUCTURE NETRESOURCE
   MEMBER DWORD nAttribute
   MEMBER @ FILETIME  cT
   MEMBER @ FILETIME  AT
   MEMBER @ FILETIME  LT
   MEMBER DWORD nSizeH
   MEMBER DWORD nSizeL
   MEMBER DWORD nRes0
   MEMBER DWORD nRes1
   MEMBER szstr cFilename size 260
   MEMBER szstr cAltName size 14
END STRUCTURE

*####################################################
